//To Make : g++ -o direct_id direct_id.cpp

# include <iostream>
# include <iomanip>
# include <string>
# include <cstring>
# include <fstream>
# include <limits>
# include <sstream>
# include <algorithm>
#include <functional>
#include <cctype>
#include <locale>
#include <vector>
#include <list>
using namespace std;
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <pthread.h>
#include <omp.h>
#include <sys/syscall.h>
//#define NUM_TOP_LIMIT 100

// from : http://stackoverflow.com/questions/236129/splitting-a-string-in-c
void split(string &s1, string s2[]){
	istringstream iss(s1);
	int j=0;
	do{
	  string sub;
	  iss >> sub;
	  if (sub != "")
	  {
	    s2[j] = sub;
	    j++;
	  }
	} while(iss);
}

void split_string(string str, vector<string> &tokens){
  tokens.clear();
  string buf;
  stringstream ss(str);
  while (ss >> buf) { tokens.push_back(buf); }
}

double Abs(double Nbr){
    if( Nbr >= 0 )
        return Nbr;
    else
        return -Nbr;
}

float calc_norm(vector<vector<float> > &covar_diff){
int i=0,j=0;
int covar_size=0;
float sum=0,norm=0;
vector <float> sum_vector;

covar_size=covar_diff.size();

//Column sums
for(j=0;j< covar_size;j++){
	sum=0;
	for(i=0; i < covar_size;i++){
		sum=sum+Abs(covar_diff[i][j]);
	}
	sum_vector.push_back(sum);
}
vector<float>::const_iterator index;
index = max_element(sum_vector.begin(), sum_vector.end());
norm= *index;
return norm;
}

struct sort_pred {
    bool operator()(const std::pair<int,float> &left, const std::pair<int,float> &right) {
        return left.second > right.second;
  }
};

void remove_duplicates(vector<pair<int,string> > &screened_reslist){
	for(int i=0; i < screened_reslist.size()-1;i++){
		for(int j=i+1; j < screened_reslist.size();j++){
			if((screened_reslist[i].first == screened_reslist[j].first) && (screened_reslist[i].second == screened_reslist[j].second)){
				screened_reslist.erase(screened_reslist.begin()+j);
				j--;
      }
    }
  }
}

int main(int argc,char* argv[]){

  int i=0,j=0,k=0,l=0;
  int Natoms_covar1=0, Natoms_covar2=0,Natoms_pdb=0;
  int gmx_flag=0;
  int element1=0,element2=0;
  int num_top_score=0, prev_value=0;
  int num_top_limit=100;
  float norm=0;
  char print_buffer[300];
  string sLine;
  string sLine_array[20];
  string str_covar_f1, str_covar_f2;
  vector<int> res_no;
  vector<float> row_elements;
  vector<string> covar1_ipdata, covar2_ipdata;
  vector<string> atom_name;
  vector<string> res_name;
  vector<string> vec_sLine_array;
  vector<vector<float> > covar1, covar2, covar_diff;
  vector<pair<int, float > > struct_elements_row;
  vector<pair<int, float > > struct_elements_col;
  vector<pair<int, string > > screened_reslist;
  
  cout << "DIRECT-ID will extract structural features with biggest changes between" << endl;
  cout << "two covariance matrices; ref PDB is used to map the elements" << endl;
  cout << "in the covar matrices, with the corresponding atoms/residue info" << endl;
  cout << endl;

	if (argc < 5){
        cout <<" Usage : direct_id <3NXN/3NX3N> <inp_covar_1> <inp_covar_2> <inp_ref_pdb> <op_struct_elements_filename> / optional : <# of elements to be printed>, default set to 100 " << endl;
        return 0;
    }


  if (strcmp(argv[1], "3NXN")==0){
  	cout << "Cov matrices expected to contain: 3N x N elements" << endl;
  	gmx_flag=1;
  }
  else{
  	if(strcmp(argv[1],"3NX3N")==0)
  	{
  		cout << "Cov matrices expected to contain: 3N x 3N elements" << endl;
  		gmx_flag=0;
  	}
  	else
  	{
  		cout << "This flag has to be set and the two options are : 1) 3NXN 2) 3NX3N " << endl;
  		return -1;
  	}
  }

  str_covar_f1 = (string) argv[2];
  ifstream covar_f1(str_covar_f1.c_str(),ifstream::in);
  
  if (!covar_f1.is_open()){
  	cout << "Cannot access "<< 	argv[1] << " quitting " << endl;
  	return -1;
  }
  
  str_covar_f2 = (string) argv[3];
  ifstream covar_f2(str_covar_f2.c_str(),ifstream::in);
  
  if (!covar_f2.is_open()){
  	cout << "Cannot access "<< 	argv[2] << " quitting " << endl;
  	return -1;
  }

  ifstream f_pdb(argv[4],ifstream::in);
  
  if(!f_pdb.is_open()){
  	cout << "Cannot access "<< 	argv[4] << " quitting " << endl;
  	return -1;
  }

  FILE *f_struct_elem;
  
  f_struct_elem = fopen(argv[5],"w");
  
  if (f_struct_elem == NULL){
  	cout << "Cannot open file " << argv[5] << " for writing list of structural element pairs; quitting " << endl;
  	return -1;
  }
  
  if (!argv[6]){
  	cout << "Did not receive a number for printing the list of features; setting to default 100" << endl;
  	num_top_limit=100;
  }
  else{
  	num_top_limit=(int) atoi(argv[6]);
  	if(num_top_limit != num_top_limit){
  		cout << "Invalid number for printing the list of features; setting to default 100" << endl;
  	}
  }

  fprintf(f_struct_elem, "%s\n","Pairs of atoms with biggest changes in their correlated motions between the two covariance matrices");
  fprintf(f_struct_elem, "%4s\t%4s\t%4s\t\t%4s\t%4s\t%4s\t%4s\n","A1","R1", "#1", "A2", "R2", "#2", "RANK");

  Natoms_pdb=0;
  while (!f_pdb.eof()){
    getline(f_pdb,sLine);
    if ((sLine.substr(0,4) == "ATOM") || (sLine.substr(0,6) == "HETATM")){
      split(sLine, sLine_array);
      atom_name.push_back(sLine_array[2]);
      res_name.push_back(sLine_array[3]);
    if(sLine.c_str()[21] != ' '){
  	  res_no.push_back(atoi(sLine_array[5].c_str()));
    }
    else{
      res_no.push_back(atoi(sLine_array[4].c_str()));
    }
      Natoms_pdb++;
    }
    if(sLine == ""){
  	  break;
    }
  }

  i=0;
  while (!covar_f1.eof()){
  	getline(covar_f1,sLine);
  	if(sLine == ""){
  		break;
  	}
  	covar1_ipdata.push_back(sLine);
  	i++;
  }
 
  if (gmx_flag)
  { 
    Natoms_covar1 = (int) sqrt(i/3);
  }
  else
  {
    Natoms_covar1 = (int) (i/3);
  }

  i=0;
  while(!covar_f2.eof()){	
    getline(covar_f2,sLine);
    if(sLine == ""){
    	break;
    }	
    covar2_ipdata.push_back(sLine);
    i++;
  }

  if (gmx_flag)    
  {
    Natoms_covar2 = (int) sqrt(i/3);
  }
  else
  {
    Natoms_covar2 = (int) (i/3);
  }

  if ( (Natoms_covar1 != Natoms_covar2) || ( Natoms_covar1 != Natoms_pdb) || (Natoms_covar2 != Natoms_pdb)){
    cout << "MISMATCH in # of atoms used for covar calc & ref PDB " << endl;
    cout << "  covar 1 : "  << Natoms_covar1 << " covar 2 : " << Natoms_covar2 << " ref PDB : " << Natoms_pdb << " quitting " << endl;
    return -1;
  }
  else{
      cout << "# of atoms used for covar calc in files 1 & 2 match with the ref PDB "<< endl;
      cout << "  covar 1 : "  << Natoms_covar1 << " ; covar 2 : " << Natoms_covar2 << " ; ref PDB : " << Natoms_pdb << endl; 
      cout << "  proceeding with analysis" << endl;
      cout << endl;
  }

  if (gmx_flag){
    for (i=0; i < covar1_ipdata.size();i++){
      k=i+Natoms_covar1;
      for (j=i; j < k; j++,i++){
      	split(covar1_ipdata[j],sLine_array);
      
      	for (l=0; l < 3;l++){
      		row_elements.push_back(atof(sLine_array[l].c_str()));
      	}
      }
    covar1.push_back(row_elements);
    row_elements.clear();
    i--;
    }
    
    for (i=0; i < covar2_ipdata.size();i++){
      k=i+Natoms_covar2;
      for (j=i; j < k; j++,i++){
        split(covar2_ipdata[j],sLine_array);
    	for (l=0; l < 3;l++){
          row_elements.push_back(atof(sLine_array[l].c_str()));
    	}
    }
    covar2.push_back(row_elements);
    row_elements.clear();
    i--;
  }
}
  else{
    for(i=0; i < covar1_ipdata.size();i++){
      split_string(covar1_ipdata[i],vec_sLine_array);
      for(j=0; j < vec_sLine_array.size();j++){
        row_elements.push_back(atof(vec_sLine_array[j].c_str()));
      }
      covar1.push_back(row_elements);
      row_elements.clear();
      vec_sLine_array.clear();
    }
  
    for(i=0; i < covar2_ipdata.size();i++){
      split_string(covar2_ipdata[i],vec_sLine_array);
      for(j=0; j < vec_sLine_array.size();j++){
        row_elements.push_back(atof(vec_sLine_array[j].c_str()));
      }
      covar2.push_back(row_elements);
      row_elements.clear();
      vec_sLine_array.clear();
    }
  
  }

  covar_diff = covar1;

  for(i=0; i < covar1.size();i++){
    for(j=0; j < covar1[i].size();j++){
    	covar_diff[i][j] = Abs(covar1[i][j] - covar2[i][j]);
    }
  }

  norm=calc_norm(covar_diff);

  for(j=0; j < covar_diff.size();j++){
    for(k=0; k < covar_diff[j].size();k++){
      struct_elements_row.push_back(make_pair(j,covar_diff[j][k]));
      struct_elements_col.push_back(make_pair(k,covar_diff[j][k]));	
    }
  }	

  sort(struct_elements_row.begin(),struct_elements_row.end(),sort_pred());
  sort(struct_elements_col.begin(),struct_elements_col.end(),sort_pred());

  num_top_score=0;
  prev_value=0;
  element1=0;
  element2=0;

  for (j=0; (j < struct_elements_row.size() ) && (num_top_score < num_top_limit);j++){
    if ((prev_value != struct_elements_row[j].second) && (round(struct_elements_row[j].first/3) != element2) && (round(struct_elements_col[j].first/3) !=element1) && (struct_elements_row[j].first != struct_elements_col[j].first)){
    element1=round(struct_elements_row[j].first/3);
    element2=round(struct_elements_col[j].first/3);
    fprintf(f_struct_elem,"%4s\t%4s\t%4d\t\t%4s\t%4s\t%4d\t%3.2f\n", atom_name[element1].c_str(), res_name[element1].c_str(),res_no[element1], atom_name[element2].c_str(), res_name[element2].c_str(), res_no[element2], covar_diff[struct_elements_row[j].first][struct_elements_col[j].first]);

    num_top_score++;
    prev_value = struct_elements_row[j].second;

    screened_reslist.push_back(make_pair(res_no[element1],res_name[element1]));
    screened_reslist.push_back(make_pair(res_no[element2],res_name[element2]));
    }
  }

  fclose(f_struct_elem);
  struct_elements_row.clear();
  struct_elements_col.clear();

  sort(screened_reslist.begin(),screened_reslist.end());

  remove_duplicates(screened_reslist);

  cout << std::fixed << std::setw(11) << "Norm" << "\t" << "Res list " << endl;
  cout << endl;

  cout << std::fixed << std::setw(11) << std::setprecision(1) << norm << "\t";

  j=0;
  for (i=0; i < screened_reslist.size();i++){
    if (j < 5){
      if (i == (screened_reslist.size()-1)){
        cout << screened_reslist[i].second << " " << screened_reslist[i].first << endl;
      }
      else{
        cout << screened_reslist[i].second << " " << screened_reslist[i].first << ", ";
      }	
      j++;
    }
    else{
      cout << endl;
      cout << std::fixed << std::setw(11) << std::setprecision(1) << " " << "\t";
      j=0;
      i--;
    }
  }
  cout << endl;
  return 0;
}
